# Try to find aio.h for AsyncRequest


IF (ASYNCREQUEST_INCLUDE_DIR)
	# Already in cache, be silent
	SET(ASYNCREQUEST_FIND_QUIETLY TRUE)
ENDIF (ASYNCREQUEST_INCLUDE_DIR)

FIND_PATH(ASYNCREQUEST_INCLUDE_DIR aio.h)
 
IF(ASYNCREQUEST_INCLUDE_DIR) 
	 SET(ASYNCREQUEST_FOUND TRUE) 
ENDIF(ASYNCREQUEST_INCLUDE_DIR) 

IF(ASYNCREQUEST_FOUND) 
	set(CMAKE_REQUIRED_INCLUDES ${ASYNCREQUEST_INCLUDE_DIR})
	set(CMAKE_REQUIRED_INCLUDES)
	IF(NOT ASYNCREQUEST_FIND_QUIETLY) 
		MESSAGE(STATUS "Found AsyncRequest headers: ${ASYNCREQUEST_INCLUDE_DIR}/aio.h") 
	ENDIF(NOT ASYNCREQUEST_FIND_QUIETLY) 
ELSE(ASYNCREQUEST_FOUND) 
	IF(AsyncRequest_FIND_REQUIRED) 
		MESSAGE(FATAL_ERROR "Could not find AsyncRequest") 
	ENDIF(AsyncRequest_FIND_REQUIRED) 
ENDIF(ASYNCREQUEST_FOUND) 

MARK_AS_ADVANCED(
	ASYNCREQUEST_INCLUDE_DIR
	ASYNCREQUEST_LIBRARIES
	ASYNCREQUEST_SECOND_ARGUMENT_IS_CONST
)
