# Try to find syslog.h for Syslog


IF (SYSLOG_INCLUDE_DIR)
	# Already in cache, be silent
	SET(SYSLOG_FIND_QUIETLY TRUE)
ENDIF (SYSLOG_INCLUDE_DIR)

FIND_PATH(SYSLOG_INCLUDE_DIR syslog.h)
 
IF(SYSLOG_INCLUDE_DIR) 
	 SET(SYSLOG_FOUND TRUE) 
ENDIF(SYSLOG_INCLUDE_DIR) 

IF(SYSLOG_FOUND) 
	set(CMAKE_REQUIRED_INCLUDES ${SYSLOG_INCLUDE_DIR})
	set(CMAKE_REQUIRED_INCLUDES)
	IF(NOT SYSLOG_FIND_QUIETLY) 
		MESSAGE(STATUS "Found Syslog headers: ${SYSLOG_INCLUDE_DIR}/syslog.h") 
	ENDIF(NOT SYSLOG_FIND_QUIETLY) 
ELSE(SYSLOG_FOUND) 
	IF(Syslog_FIND_REQUIRED) 
		MESSAGE(FATAL_ERROR "Could not find Syslog") 
	ENDIF(Syslog_FIND_REQUIRED) 
ENDIF(SYSLOG_FOUND) 

MARK_AS_ADVANCED(
	SYSLOG_INCLUDE_DIR
	SYSLOG_LIBRARIES
	SYSLOG_SECOND_ARGUMENT_IS_CONST
)
